package de.blitzkasse.mobilegastrolite.util;

import de.blitzkasse.mobilegastrolite.config.Constants;

public class LiteCryptUtil {
	
	private static final String LOG_TAG = "LiteCryptUtil";
	private static final boolean PRINT_LOG = Constants.DEBUG_LOG && false;

	private final static String[] PLAINARRAY = new String [] {
		"!","#","$","%","&","'","(",")","*","+",
		"M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","[",
		"]","^","_","`","a","c","d","e","f","g","h","i","j","k","l","m","b",
		"-",".","/","0","1","2","3","4","5","6","7","8","9",":",";","<",
		"=",">","?","@","A","B","C","D","E","F","G","H","I","J","K","L",
		"n","o","p","q","r","s","t","u","v","w","x","y","z","{","|","}"
	};

	private final static String[] CODEDARRAY = new String [] {
		"aja","ajb","ajc","ajd","aje","ajf","ajg","ajh","aji","aaj",
		"bja","bjb","bjc","bjd","bje","bjf","bjg","bjh","bji","baj","baa","bab","bac","bad","bae","baf",
		"cja","cjb","cjc","cjd","cje","cjf","cjg","cjh","cji","caj","caa","cab","cac","cad","cae","caf",
		"dja","djb","djc","djd","dje","djf","djg","djh","dji","daj","daa","dab","dac","dad","dae","daf",
		"eja","ejb","ejc","ejd","eje","ejf","ejg","ejh","eji","eaj","eaa","eab","eac","ead","eae","eaf",
		"fja","fjb","fjc","fjd","fje","fjf","fjg","fjh","fji","faj","faa","fab","fac","fad","fae","faf"
	};	
	
	private static final int CODED_CHAR_LENGTH = 3;
	
	public static String encryptText(String plainText) {
		try {
			String encrypted = "";
			for (int j=0; j < plainText.length(); j++) {
				String plainChar = plainText.substring(j, j + 1);
				int i = StringsUtil.getIndexOfString(PLAINARRAY, plainChar);
				encrypted += plainChar.replace(PLAINARRAY[i], CODEDARRAY[i]); 
			}	
			return encrypted;
		} catch (Exception e) {}
		return null;
	}
	
	
    public static String decryptText(String cryptedString)
    {
        String decrypted = null;
        try
        {
            decrypted = "";
            for (int i = 0; i < cryptedString.length(); i = i + CODED_CHAR_LENGTH)
            {
                String codedChar = cryptedString.substring(i, i + CODED_CHAR_LENGTH);
                int codedIndex = StringsUtil.getIndexOfString(CODEDARRAY, codedChar);
                decrypted += PLAINARRAY[codedIndex];
            }
            return decrypted;
        }
        catch (Exception e) {}
        return null;
    }

}
